[![Build Status](https://travis-ci.org/mediapeers/postjob.svg?branch=master)](https://travis-ci.org/mediapeers/postjob)

# Postjob

The `postjob` gem implements a simple way to have restartable, asynchronous, and distributed processes.

## Install

To install gem run `gem install postjob` or add `gem postjob` to your Gemfile and bundle.

## stable vs master

Postjob development generally happens in a master branch. "stable" versions are maintained in a stable branch.

Current stable version: 0.2.0
Currently released master version: 0.3.0

### Pre 1.0 versioning policy

Until release of version 1.0 we'll maintain "stable" versions with even minor version
numbers (e.g. "0.2"), and "unstable" in uneven minor versions (e.g. 0.3).

Stable versions are in production use; unstable versions are released for various
tests and experiments.

With version 1.0 we'll switch to semantic versioning.
 
## Development setup

1. Make sure you have PostgreSQL >= 9.5 installed
2. Clone repo `git clone git@github.com:mediapeers/postjob.git && cd postjob`
3. Run `./scripts/setup` to bundle and setup DB (requires passwordless postgres user).

To install this gem onto your local machine, run `bundle exec rake install`.

## Tests

Tests are set up to run twice, once against an ActiveRecord adapter, and once against a Simple::SQL provided adapter. To run the full test suite run

    make ci_tests

To run a single set of tests - this is usually fine during development - run

    bundle exec rspec

## Release gem

To release a new version of this gem , run `rake release`, which will bump the version number,
create a git tag for the version, push git commits and tags, and push the `.gem` file
to [rubygems.org](https://rubygems.org). 

To release a new stable version of this gem , run `[VERSION=0.4.3] rake release:stable`, which
does the same, but based on the stable branch.

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/mediapeers/postqueue.

## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).
