require "spec_helper"

describe "Heartbeat Events" do
  include TestHelper

  describe "::Postjob::Queue.host_heartbeat" do
    def run!
      ::Postjob::Queue.host_heartbeat(null_host_id, {})
    end

    it "creates a heartbeat event" do
      run!

      event = Simple::SQL.ask <<~SQL, into: OpenStruct
        SELECT * FROM postjob.events
        WHERE name='heartbeat' ORDER BY created_at DESC
      SQL

      expect(event.worker_session_id).to be_nil
      expect(event.host_id).to eq(null_host_id)
    end
  end
end
