require "spec_helper"

module FastFailWorkflow
  def self.run
    await async :manual, timeout: 0.000001
  end

  Postjob.register_workflow self
end

describe "timeout" do
  context "with an instant timeout" do
    let!(:id) { Postjob.enqueue! "FastFailWorkflow" }

    before do
      Postjob.process_all
    end

    it "fails the childjob with a timeout" do
      manual_job = TestHelper.load_job "SELECT * FROM postjobs WHERE parent_id=$1", id
      expect(manual_job.status).to eq("timeout")
      expect { manual_job.resolve }.to raise_error(Timeout::Error)
    end

    xit "fails the mainjob" do
      job = TestHelper.load_job(id)
      expect(job.status).to eq("err")
      expect { job.resolve }.to raise_error(Postjob::Error)
    end
  end
end
