require "spec_helper"

module BarWorkflow
  def self.run
    "Foo"
  end

  Postjob.register_workflow self, version: "1.2"
end

describe "Postjob.process_job" do
  include TestHelper

  let!(:job) { Postjob.enqueue! "BarWorkflow" }

  it "runs the job returning either nil or :shutdown" do
    # Note: the :shutdown case is really hard to test.
    expect(Postjob.process_job(newest_job)).to eq(nil)
  end

  it "updates the job version" do
    expect(newest_job.workflow_version).to eq("")
    Postjob.process_job(newest_job)
    expect(newest_job.workflow_version).to eq("1.2")
  end
end
