require "spec_helper"

describe "Postjob::WorkerSession.start!" do
  let(:store_path) { ".postjob.test.host_id" }

  def session_count
    Simple::SQL.ask "SELECT count(*) from postjob.worker_sessions"
  end

  let(:workflows_with_versions) { %w(Foo Foo@0) }

  it "creates a new session" do
    expect do
      session = Postjob::WorkerSession.start!(workflows_with_versions, queues: [ Postjob::DEFAULT_QUEUE ])
      expect(session.id).to match(/[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}/i)
    end.to change { session_count }.by(1)
  end
end
