require "spec_helper"

module WorkflowWithChild
  def self.my_string
    "my string"
  end

  def self.run
    r = async :my_string
    await r
  end

  Postjob.register_workflow self
end

describe "Sub Workflows" do
  include TestHelper

  let!(:id) { Postjob.enqueue! "WorkflowWithChild" }

  it "runs the job returning the result" do
    Postjob.process_all
    processed_job = load_job(id)
    expect(processed_job.status).to eq("ok")
    expect(processed_job.resolve).to eq("my string")
  end
end
