if ENV["USE_ACTIVE_RECORD"]
  require_relative "configure_active_record"
else
  require_relative "configure_simple_sql"
end

RSpec.configure do |config|
  # This test uses the nil host_id, which is configured during migration.
  def null_host_id
    "00000000-0000-0000-0000-000000000000"
  end

  config.around(:each) do |example|
    Simple::SQL.ask "DELETE FROM postjob.postjobs"
    Simple::SQL.ask "DELETE FROM postjob.tokens"
    Simple::SQL.ask "DELETE FROM postjob.events"
    Simple::SQL.ask "DELETE FROM postjob.tokens"

    # Simple::SQL.ask "DELETE FROM postjob.hosts"
    # Simple::SQL.ask "DELETE FROM postjob.worker_sessions"

    example.run
  end
end

require "postjob/migrations"

Postjob::Migrations.unmigrate!
Postjob::Migrations.migrate!

Simple::SQL.ask "SET search_path = postjob, public, pg_catalog"
