Postjob.send :public, :process_job

module TestHelper
  extend self

  def jobs_count
    Simple::SQL.ask "SELECT count(*) FROM postjobs"
  end

  def newest_job
    Simple::SQL.ask "SELECT * FROM postjobs ORDER BY id DESC", into: Postjob::Job
  end

  def load_job(id_or_sql, *args)
    case id_or_sql
    when Integer
      Simple::SQL.ask "SELECT * FROM postjobs WHERE id=$1", id_or_sql, into: Postjob::Job
    else
      Simple::SQL.ask id_or_sql, *args, into: Postjob::Job
    end
  end

  def load_token(job)
    Simple::SQL.ask "SELECT token FROM tokens WHERE postjob_id=$1", job.id
  end

  def resolve_all
    query = "SELECT id FROM postjob.postjobs WHERE status NOT IN ('ok', 'failed', 'timeout')"

    loop do
      break unless Simple::SQL.ask(query)
      Postjob.process_all
      sleep 0.05
    end
  end

  def print_jobs
    sql = <<~SQL
      SELECT
        id,
        workflow AS job,
        workflow_method AS m,
        args,
        status,
        (results->0)::varchar AS result,
        failed_attempts AS attempts,
        EXTRACT(EPOCH FROM ((now() at time zone 'utc') - created_at)) AS age,
        EXTRACT(EPOCH FROM (next_run_at - (now() at time zone 'utc'))) AS next_run_in,
        error,
        error_message,
        (error_backtrace->0)::varchar AS backtrace
        FROM postjobs
      ORDER BY id
    SQL

    Simple::SQL.print(sql)
  end
end
